# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from pal_detection_msgs/RecognizedObject.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import sensor_msgs.msg

class RecognizedObject(genpy.Message):
  _md5sum = "ac3fbc481abe751cad38199e3707858d"
  _type = "pal_detection_msgs/RecognizedObject"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """# Contains information about the class of a found object, along with its confidence and ROI of detection

# class: The respective class type of the found object
string object_class

# confidence: how sure you are it is that object and not another one.
# It is between 0 and 1 and the closer to one it is the better
float32 confidence

# bounding_box: The region of the image, where the object is found
sensor_msgs/RegionOfInterest bounding_box

================================================================================
MSG: sensor_msgs/RegionOfInterest
# This message is used to specify a region of interest within an image.
#
# When used to specify the ROI setting of the camera when the image was
# taken, the height and width fields should either match the height and
# width fields for the associated image; or height = width = 0
# indicates that the full resolution image was captured.

uint32 x_offset  # Leftmost pixel of the ROI
                 # (0 if the ROI includes the left edge of the image)
uint32 y_offset  # Topmost pixel of the ROI
                 # (0 if the ROI includes the top edge of the image)
uint32 height    # Height of ROI
uint32 width     # Width of ROI

# True if a distinct rectified ROI should be calculated from the "raw"
# ROI in this message. Typically this should be False if the full image
# is captured (ROI not used), and True if a subwindow is captured (ROI
# used).
bool do_rectify
"""
  __slots__ = ['object_class','confidence','bounding_box']
  _slot_types = ['string','float32','sensor_msgs/RegionOfInterest']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       object_class,confidence,bounding_box

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(RecognizedObject, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.object_class is None:
        self.object_class = ''
      if self.confidence is None:
        self.confidence = 0.
      if self.bounding_box is None:
        self.bounding_box = sensor_msgs.msg.RegionOfInterest()
    else:
      self.object_class = ''
      self.confidence = 0.
      self.bounding_box = sensor_msgs.msg.RegionOfInterest()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.object_class
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_get_struct_f4IB().pack(_x.confidence, _x.bounding_box.x_offset, _x.bounding_box.y_offset, _x.bounding_box.height, _x.bounding_box.width, _x.bounding_box.do_rectify))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.bounding_box is None:
        self.bounding_box = sensor_msgs.msg.RegionOfInterest()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.object_class = str[start:end].decode('utf-8')
      else:
        self.object_class = str[start:end]
      _x = self
      start = end
      end += 21
      (_x.confidence, _x.bounding_box.x_offset, _x.bounding_box.y_offset, _x.bounding_box.height, _x.bounding_box.width, _x.bounding_box.do_rectify,) = _get_struct_f4IB().unpack(str[start:end])
      self.bounding_box.do_rectify = bool(self.bounding_box.do_rectify)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.object_class
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_get_struct_f4IB().pack(_x.confidence, _x.bounding_box.x_offset, _x.bounding_box.y_offset, _x.bounding_box.height, _x.bounding_box.width, _x.bounding_box.do_rectify))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.bounding_box is None:
        self.bounding_box = sensor_msgs.msg.RegionOfInterest()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.object_class = str[start:end].decode('utf-8')
      else:
        self.object_class = str[start:end]
      _x = self
      start = end
      end += 21
      (_x.confidence, _x.bounding_box.x_offset, _x.bounding_box.y_offset, _x.bounding_box.height, _x.bounding_box.width, _x.bounding_box.do_rectify,) = _get_struct_f4IB().unpack(str[start:end])
      self.bounding_box.do_rectify = bool(self.bounding_box.do_rectify)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_f4IB = None
def _get_struct_f4IB():
    global _struct_f4IB
    if _struct_f4IB is None:
        _struct_f4IB = struct.Struct("<f4IB")
    return _struct_f4IB
